
package parser;

import java.util.*;
import java.io.*;

public class SimpleScriptParser extends SimpleScriptSyntax {
    protected Node createNode(int symbolID, NodeInitializationParameters parameters) throws ParseException {
        return createNode(symbolID, parameters, true);
    }
    public int run(String name, Reader reader, int tabStop) throws ParseException, IOException {
        Root root = parseRoot(name, reader, tabStop);
        root.fix();
        return root.run();
    }
    public int run(String name, CharSequence image, int tabStop) throws ParseException {
        Root root = parseRoot(name, image, tabStop);
        root.fix();
        return root.run();
    }
    public int run(File file, String encoding) throws ParseException, IOException {
        Root root = parseRoot(file, encoding);
        root.fix();
        return root.run();
    }
    
    public static void main(String[] args) {
        try {
            System.out.println(new SimpleScriptParser().run("-", new InputStreamReader(System.in), 8));
        } catch (Exception x) {
            x.printStackTrace();
        }
    }
}

