// Test.java
import java.io.*;
import java.util.*;

public class Test {
    public static void main(String[] args) throws Exception {
        String text = args[0];
        System.out.println("input: " + text);
        
        ExpressionParser p = new ExpressionParser();
        ExpressionParser.Node expr = p.parseRoot("test", text, 8);
        double value = evaluate(expr);
        System.out.println(value);
    }
    public static double evaluate(ExpressionParser.Node node) {
        if (node instanceof ExpressionParser.Token) {
            ExpressionParser.Token token = (ExpressionParser.Token) node;
            String image = token.getImage();
            return Double.parseDouble(image);
        } else if (node instanceof ExpressionParser.Addition) {
            double v1 = evaluate( <+の左の式> );
            double v2 = evaluate( <+の右の式> );
            return v1 + v2;
        } else if (node instanceof ExpressionParser.Subtraction) {
            double v1 = evaluate( <-の左の式> );
            double v2 = evaluate( <-の右の式> );
            return v1 - v2;
        } else if (node instanceof ExpressionParser.Multiplication) {
            double v1 = evaluate( <*の左の式> );
            double v2 = evaluate( <*の右の式> );
            return v1 * v2;
        } else if (node instanceof ExpressionParser.Division) {
            double v1 = evaluate( </の左の式> );
            double v2 = evaluate( </の右の式> );
            return v1 / v2;
        } else if (node instanceof ExpressionParser.Paren) {
            double v = evaluate( <括弧に囲まれた式> );
            return v;
        } else if (node instanceof ExpressionParser.Root) {
            double v = evaluate( <式> );
            return v;
        } else {
            throw new IllegalArgumentException("" + node);
        }
    }
}
