
import java.util.*;
import java.io.*;
import junit.framework.*;
import parser.*;
import parser.AmbiguousSyntax1.*;

public class Ambiguous1_Test extends TestCase {
    public static void main(String[] args) {
        junit.textui.TestRunner.main(new String[] { Ambiguous1_Test.class.getName() });
    }
    
    public Ambiguous1_Test(String name) {
        super(name);
    }
    
    private StringBuffer input = new StringBuffer("xx");
    private Object[] spec1 = new Object[] { "Test1",
        new Object[] { "Test1Absorber",
            new Object[] { "A", "x", "x" },
            new Object[] { "B", "x", "x" },
        },
    };
    private Object[] spec2 = new Object[] { "Test2Absorber",
        new Object[] { "Test2",
            new Object[] { "C", "x", "x" },
        },
        new Object[] { "Test2",
            new Object[] { "D", "x" },
            new Object[] { "D", "x" },
        },
    };
    
    public void test1() throws IOException, ParseException {
        Node output = new AmbiguousSyntax1().parseTest1("test", input, 8);
        System.err.println(output);
        assertTrue(check(output, spec1));
    }
    public void test2() throws IOException, ParseException {
        Node output = new AmbiguousSyntax1().parseTest2("test", input, 8);
        System.err.println(output);
        assertTrue(check(output, spec2));
    }
    
    private boolean check(Node output, Object[] spec) {
        if (output.getWrappedAmbiguityAbsorber() != null)
            output = output.getWrappedAmbiguityAbsorber();
        
        Node[] o = (Node[]) output.getChildNodes().toArray(new Node[0]);
        String nodeType;
        nodeType = output.getClass().getName();
        nodeType = nodeType.substring(nodeType.lastIndexOf('.') + 1);
        nodeType = nodeType.substring(nodeType.lastIndexOf('$') + 1);
        
        if (!nodeType.equals(spec[0]))
            return false;
        if (o.length != spec.length - 1)
            return false;
        
        if (!nodeType.endsWith("Absorber")) {
            for (int i = 0; i < o.length; i++) {
                if ((o[i] instanceof Token) != (spec[i + 1] instanceof String))
                    return false;
                if (o[i] instanceof Token) {
                    if (!(((Token) o[i]).getImage()).equals(spec[i + 1]))
                        return false;
                } else {
                    if (!check(o[i], (Object[]) spec[i + 1]))
                        return false;
                }
            }
            return true;
        } else {
            assertTrue(o.length == 2);
            if (check(o[0], (Object[]) spec[1]) && check(o[1], (Object[]) spec[2]))
                return true;
            if (check(o[0], (Object[]) spec[2]) && check(o[1], (Object[]) spec[1]))
                return true;
            return false;
        }
    }
}
